"use strict";
var __assign = (this && this.__assign) || Object.assign || function(t) {
    for (var s, i = 1, n = arguments.length; i < n; i++) {
        s = arguments[i];
        for (var p in s) if (Object.prototype.hasOwnProperty.call(s, p))
            t[p] = s[p];
    }
    return t;
};
Object.defineProperty(exports, "__esModule", { value: true });
var stylable_1 = require("stylable");
var StylableContext = (function () {
    function StylableContext(config) {
        this.sheets = [];
        this.style = null;
        this.resolver = new stylable_1.Resolver({});
        this.generator = new stylable_1.Generator(__assign({}, config, { resolver: this.resolver }));
    }
    StylableContext.prototype.add = function (sheet) {
        this.resolver.add(sheet.namespace, sheet);
        if (sheet.source) {
            this.resolver.add(sheet.source, sheet);
        }
        this.sheets.push(sheet);
    };
    StylableContext.prototype.registerMixin = function (name, mixin) {
        this.resolver.add(name, mixin);
    };
    StylableContext.prototype.attach = function () {
        var style = this.style || (this.style = document.createElement('style'));
        stylable_1.Generator.generate(this.sheets, this.generator).forEach(function (css) {
            style.appendChild(document.createTextNode(css));
        });
        document.head.appendChild(this.style);
    };
    return StylableContext;
}());
exports.StylableContext = StylableContext;
//# sourceMappingURL=runtime-context.js.map