/// <reference types="react" />
import { Stylesheet } from "stylable";
import { StylableComponent, SBStatelessComponent, StateLess, SBComponentProps } from "./types";
declare function SBComponent<T extends React.ComponentClass<any>>(Base: T, stylesheet: StylesheetInput): StylableComponent<T>;
declare function SBComponent<T>(stylesheet: StylesheetInput): Function;
declare function SBStateless<T, C = object>(renderFunction: StateLess<T, C>, stylesheet: StylesheetInput): SBStatelessComponent<T>;
declare function defineMixin<T>(name: string, mixinFunction: (options: T) => object): (options: T) => object;
export declare type StylesheetInput = Stylesheet | {
    $stylesheet: Stylesheet;
};
export { SBComponent, SBStateless, defineMixin };
declare module 'react' {
    interface HTMLAttributes<T> extends SBComponentProps {
    }
}
